[LTP] [PATCH v2] test_children_cleanup.sh: Fix race condition
Martin Doucha
mdoucha@suse.cz
Tue Feb 15 11:20:53 CET 2022
Processes can stay alive for a short while even after receiving SIGKILL.
Give the child in subprocess cleanup libtest up to 5 seconds to fully exit
or change state to zombie before reporting that it was left behind.
Signed-off-by: Martin Doucha <mdoucha@suse.cz>
---
Changes since v1: Report success even if the child gets stuck in zombie state
lib/newlib_tests/test_children_cleanup.sh | 23 +++++++++++++++++------
1 file changed, 17 insertions(+), 6 deletions(-)
diff --git a/lib/newlib_tests/test_children_cleanup.sh b/lib/newlib_tests/test_children_cleanup.sh
index 4b4e8b2f0..23408c1bc 100755
--- a/lib/newlib_tests/test_children_cleanup.sh
+++ b/lib/newlib_tests/test_children_cleanup.sh
@@ -10,10 +10,21 @@ rm "$TMPFILE"
if [ "x$CHILD_PID" = "x" ]; then
echo "TFAIL: Child process was not created"
exit 1
-elif ! kill -s 0 $CHILD_PID &>/dev/null; then
- echo "TPASS: Child process was cleaned up"
- exit 0
-else
- echo "TFAIL: Child process was left behind"
- exit 1
fi
+
+# The child process can stay alive for a short while even after receiving
+# SIGKILL, especially if the system is under heavy load. Wait up to 5 seconds
+# for it to fully exit.
+for i in `seq 6`; do
+ CHILD_STATE=`sed -ne 's/^State:\s*\([A-Z]\).*$/\1/p' "/proc/$CHILD_PID/status" 2>/dev/null`
+
+ if [ ! -e "/proc/$CHILD_PID" ] || [ "x$CHILD_STATE" = "xZ" ]; then
+ echo "TPASS: Child process was cleaned up"
+ exit 0
+ fi
+
+ sleep 1
+done
+
+echo "TFAIL: Child process was left behind"
+exit 1
--
2.34.1
More information about the ltp
mailing list